TTParser Class Reference

the main class to read a SimpleText/TeachText/Tex-Edit file More...

`#include <TTParser.hxx>`

Inheritance diagram for TTParser:

## Public Member Functions

| TTParser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor More...
virtual | ~TTParser ()
| destructor More...
bool | checkHeader (MWAWHeader *header, bool strict=false)
| checks if the document header is correct (or not) More...
void | parse (WPXDocumentInterface *documentInterface)
| virtual function used to parse the input More...
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor More...
int | version () const
| returns the works version More...
void | setVersion (int vers)
| sets the works version More...

## Protected Member Functions

void | init ()
| inits all internal variables More...
void | createDocument (WPXDocumentInterface *documentInterface)
| creates the listener which will be associated to the document More...
void | newPage (int number)
| adds a new page More...
bool | createZones ()
| finds the different objects zones More...
bool | readStyles (MWAWEntry const &entry)
| try to read the styles ( resource styl : SimpleText,id=128, Tex-Edit,id=1000 ) More...
bool | readWRCT (MWAWEntry const &entry)
| try to read the unknown wrct structure ( only in TexEdit,id=1000 ) More...
int | computeNumPages () const
| compute the number of page of a zone More...
bool | sendText ()
| try to send the main text More...
bool | sendPicture (int id)
| try to send a picture knowing the id More...
void | flushExtra ()
| sends the data which have not yet been sent to the listener More...
MWAWInputStreamPtr | rsrcInput ()
| return the input input More...
libmwaw::DebugFile & | rsrcAscii ()
| a DebugFile used to write what we recognize when we parse the document in rsrc More...
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWParser (MWAWParserStatePtr state)
| constructor using a state More...
MWAWParserStatePtr | getParserState ()
| returns the parser state More...
MWAWHeader * | getHeader ()
| returns the header More...
MWAWInputStreamPtr & | getInput ()
| returns the actual input More...
MWAWContentListenerPtr & | getListener ()
| returns the listener More...
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension More...
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension More...
double | getFormLength () const
| returns the form length More...
double | getFormWidth () const
| returns the form width More...
double | getPageLength () const
| returns the page length (form length without margin ) More...
double | getPageWidth () const
| returns the page width (form width without margin ) More...
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser More...
void | setListener (MWAWContentListenerPtr &listener)
| sets the listener More...
void | resetListener ()
| resets the listener More...
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter More...
void | setFontConverter (MWAWFontConverterPtr fontConverter)
| sets the font convertor More...
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document More...
void | setAsciiName (char const *name)
| Debugging: change the default ascii file. More...
std::string const & | asciiName () const
| return the ascii file name More...

## Protected Attributes

shared_ptr < TTParserInternal::State > | m_state
| the state More...

## Friends

class | TTText

## Detailed Description

the main class to read a SimpleText/TeachText/Tex-Edit file

## Constructor & Destructor Documentation

TTParser::TTParser | ( | MWAWInputStreamPtr | input,
|  | MWAWRSRCParserPtr | rsrcParser,
|  | MWAWHeader * | header
| ) |  |

constructor

TTParser::~TTParser | ( |  | ) |

virtual

destructor

## Member Function Documentation

bool TTParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = `false`
| ) |  |

virtual

checks if the document header is correct (or not)

no data fork, may be ok, but this means that the file contains no text, so...

    visibly, some other applications can create ttxt file,

so check that we have at least a styl rsrc or a PICT

Implements MWAWParser.

Referenced by parse().

int TTParser::computeNumPages | ( |  | ) | const

protected

compute the number of page of a zone

Referenced by createDocument().

void TTParser::createDocument | ( | WPXDocumentInterface * | documentInterface | ) |

protected

creates the listener which will be associated to the document

Referenced by parse().

bool TTParser::createZones | ( |  | ) |

protected

finds the different objects zones

checkme: find also two times BBSR:0x250 with size 0x168, probably not in the format..

Referenced by parse().

void TTParser::flushExtra | ( |  | ) |

protected

sends the data which have not yet been sent to the listener

Referenced by parse().

void TTParser::init | ( |  | ) |

protected

inits all internal variables

Referenced by TTParser().

void TTParser::newPage | ( | int | number | ) |

protected

adds a new page

Referenced by sendText().

void TTParser::parse | ( | WPXDocumentInterface * | documentInterface | ) |

virtual

virtual function used to parse the input

Implements MWAWParser.

bool TTParser::readStyles | ( | MWAWEntry const & | entry | ) |

protected

try to read the styles ( resource styl : SimpleText,id=128, Tex-Edit,id=1000 )

Referenced by createZones().

bool TTParser::readWRCT | ( | MWAWEntry const & | entry | ) |

protected

try to read the unknown wrct structure ( only in TexEdit,id=1000 )

Referenced by createZones().

libmwaw::DebugFile & TTParser::rsrcAscii | ( |  | ) |

protected

a DebugFile used to write what we recognize when we parse the document in rsrc

Referenced by readStyles(), and readWRCT().

MWAWInputStreamPtr TTParser::rsrcInput | ( |  | ) |

protected

return the input input

Referenced by readStyles(), readWRCT(), and sendPicture().

bool TTParser::sendPicture | ( | int | id | ) |

protected

try to send a picture knowing the id

Referenced by flushExtra(), and sendText().

bool TTParser::sendText | ( |  | ) |

protected

try to send the main text

Referenced by parse().

## Friends And Related Function Documentation

friend class TTText

friend

## Member Data Documentation

shared_ptr<TTParserInternal::State> TTParser::m_state

protected

the state

Referenced by checkHeader(), computeNumPages(), createDocument(), createZones(), flushExtra(), init(), newPage(), readStyles(), sendPicture(), and sendText().

The documentation for this class was generated from the following files:

- TTParser.hxx
- TTParser.cxx